package ZnakovaRecApp;

import edu.ufl.digitalworlds.j4k.DepthMap;
import edu.ufl.digitalworlds.j4k.J4KSDK;
import edu.ufl.digitalworlds.j4k.Skeleton;

public class Kinect extends J4KSDK {

	ViewerPanel viewer = null;

	public Kinect() {
		super();
	}

	public Kinect(byte type) {
		super(type);
	}

	public void setViewer(ViewerPanel viewer) {
		this.viewer = viewer;
	}
	
	

	@Override
	public void onDepthFrameEvent(short[] depth, byte[] player_index, float[] XYZ, float[] UV) {

		if (viewer == null)
			return;
		DepthMap map = new DepthMap(getDepthWidth(), getDepthHeight(), XYZ);

		if (UV != null) {
			map.setUV(UV);
		}

		viewer.current_map = map;
	}

	@Override
	public void onSkeletonFrameEvent(boolean[] flags, float[] positions, float[] orientations, byte[] joint_status) {
		if (viewer == null || viewer.skeletons == null)
			return;
		for (int i = 0; i < getSkeletonCountLimit(); i++) {
			viewer.skeletons[i] = Skeleton.getSkeleton(i, flags, positions, orientations, joint_status, this);

		}

	}

	@Override
	public void onColorFrameEvent(byte[] color_frame) {
		if (viewer == null || viewer.videoTexture == null)
			return;
		viewer.videoTexture.update(getColorWidth(), getColorHeight(), color_frame);
	}

}