package ZnakovaRecApp;

import javax.media.opengl.GL2;

import edu.ufl.digitalworlds.j4k.DepthMap;
import edu.ufl.digitalworlds.j4k.Skeleton;
import edu.ufl.digitalworlds.j4k.VideoFrame;
import edu.ufl.digitalworlds.opengl.OpenGLPanel;

@SuppressWarnings("serial")
public class ViewerPanel extends OpenGLPanel{

	VideoFrame videoTexture;

	Skeleton skeletons[];

	DepthMap current_map = null;
	
	public float pravaRukaX, pravaRukaY;
	
	public float levaRukaX, levaRukaY;
	
	public float pravyLoketY;
	public float levyLoketY;
	
	public float paterX;
	
	public float hlavaX, hlavaY;
	
	public String znak = "";
	public String poziceRuky = "";


	public void setup() {

		GL2 gl = getGL2();
		gl.glEnable(GL2.GL_CULL_FACE);
		float light_model_ambient[] = { 0.3f, 0.3f, 0.3f, 1.0f };
		float light0_diffuse[] = { 0.9f, 0.9f, 0.9f, 0.9f };
		float light0_direction[] = { 0.0f, -0.4f, 1.0f, 0.0f };
		gl.glEnable(GL2.GL_NORMALIZE);
		gl.glShadeModel(GL2.GL_SMOOTH);

		gl.glLightModeli(GL2.GL_LIGHT_MODEL_LOCAL_VIEWER, GL2.GL_FALSE);
		gl.glLightModeli(GL2.GL_LIGHT_MODEL_TWO_SIDE, GL2.GL_FALSE);
		gl.glLightModelfv(GL2.GL_LIGHT_MODEL_AMBIENT, light_model_ambient, 0);
		gl.glLightfv(GL2.GL_LIGHT0, GL2.GL_DIFFUSE, light0_diffuse, 0);
		gl.glLightfv(GL2.GL_LIGHT0, GL2.GL_POSITION, light0_direction, 0);
		gl.glEnable(GL2.GL_LIGHT0);

		gl.glEnable(GL2.GL_COLOR_MATERIAL);
		gl.glEnable(GL2.GL_LIGHTING);
		gl.glColor3f(0.9f, 0.9f, 0.9f);

		skeletons = new Skeleton[6];

		videoTexture = new VideoFrame();

		background(0, 0, 0);
	}

	public void draw() {

		
		System.out.println(poziceRuky);
		//System.out.println(znak);
		
		GL2 gl = getGL2();
		DepthMap map = current_map;

		pushMatrix();

		if (map != null) {

			gl.glDisable(GL2.GL_LIGHTING);
			gl.glEnable(GL2.GL_TEXTURE_2D);
			gl.glColor3f(1f, 1f, 1f);
			videoTexture.use(gl);
			map.drawTexture(gl);
			gl.glDisable(GL2.GL_TEXTURE_2D);

		}
		gl.glClear(GL2.GL_DEPTH_BUFFER_BIT);

		gl.glDisable(GL2.GL_LIGHTING);
		gl.glLineWidth(3);
		gl.glColor3f(1f, 0f, 0f);
		for (int i = 0; i < skeletons.length; i++)
			if (skeletons[i] != null) {
				if (skeletons[i].getTimesDrawn() <= 10 && skeletons[i].isTracked()) {

					skeletons[i].draw(gl);
					
					
					float pravaRukaX = skeletons[i].get3DJointX(11);
					float pravaRukaY = skeletons[i].get3DJointY(11);	
					
					float levaRukaX = skeletons[i].get3DJointX(7);
					float levaRukaY = skeletons[i].get3DJointY(7);
						
					float pravyLoketY = skeletons[i].get3DJointY(9);
					float levyLoketY = skeletons[i].get3DJointY(5);
					
					float pravyLoketX = skeletons[i].get3DJointX(9);
					float levyLoketX = skeletons[i].get3DJointX(5);
					
					float paterX = skeletons[i].get3DJointX(1);
					
					float hlavaY = skeletons[i].get3DJointY(3);
					float hlavaX = skeletons[i].get3DJointX(3);
					
					
					if (pravaRukaX < paterX && pravaRukaY < pravyLoketY) {
						poziceRuky = "Doleva a dolu";
					}
					
					if (pravaRukaX < paterX && pravaRukaY > pravyLoketY) {
						poziceRuky = "Doleva a nahoru";
						
					}
					if (pravaRukaX > paterX && pravaRukaY < pravyLoketY) {
						poziceRuky = "Doprava a dolu";
			
					}
					if (pravaRukaX > paterX && pravaRukaY > pravyLoketY) {
						poziceRuky = "Doprava a nahoru";
		
					}
					
					if(pravaRukaX < paterX && pravaRukaY > pravyLoketY && levaRukaX > paterX && levaRukaY > levyLoketY && pravaRukaY < hlavaY && levaRukaY < hlavaY) {
						znak = "Medved";
					} else if(pravaRukaX > hlavaX && levaRukaX < hlavaX && pravaRukaX < pravyLoketX && levaRukaX > levyLoketX && pravaRukaY < hlavaY && levaRukaY < hlavaY && (pravaRukaY + 0.15) > hlavaY && (levaRukaY + 0.15) > hlavaY ) {
						znak = "Kocka";
					} else if (pravaRukaY > (hlavaY - 0.2) && pravaRukaY < (hlavaY + 0.01) && pravaRukaX > (paterX - 0.25) && pravaRukaX < (paterX + 0.25)){
						znak = "Kun";
					} else if (pravaRukaY < pravyLoketY && levaRukaY < levyLoketY && pravaRukaX < (levaRukaX + 0.2) && pravaRukaX > (levaRukaX - 0.2)) {
						znak = "Komar";
					} else {
						znak = "";
					}


					skeletons[i].increaseTimesDrawn();
					
				}
			}
		popMatrix();
	}


}