package ZnakovaRecApp;

import java.awt.BorderLayout;
import java.awt.GridLayout;


import javax.swing.JPanel;

import edu.ufl.digitalworlds.gui.DWApp;
import edu.ufl.digitalworlds.j4k.J4KSDK;

@SuppressWarnings("serial")
public class ZnakovaRecApp extends DWApp{

	Kinect myKinect;
	ViewerPanel main_panel;

	public void GUIsetup(JPanel p_root) {

		if (System.getProperty("os.arch").toLowerCase().indexOf("64") < 0) {
			if (DWApp.showConfirmDialog("Upozorneni",
					"<html><center><br>Varovani: Pouzivate 32bit verzi Java.<br>Tato skutecnost muze mit negativni dopad na funkcnost aplikace.<br>Doporucuji ukoncit tuto aplikaci a doporucuji nainstalovat 64bitovou verzi Java.<br><br>Prejete si ukoncit program?</center>"))
				System.exit(0);
		}

		setLoadingProgress("Priprava senzoru Kinect...", 20);
		myKinect = new Kinect();
		if (!myKinect
				.start(J4KSDK.DEPTH | J4KSDK.SKELETON | J4KSDK.COLOR | J4KSDK.XYZ | J4KSDK.UV | J4KSDK.PLAYER_INDEX)) {
			DWApp.showErrorDialog("ERROR",
					"<html><center><br>ERROR: Zarizeni Kinect nelze nacist.<br><br>1. Zkontrolujte zdali mate spravne nainstalovanou sadu Microsoft Kinect SDK .<br> 2. Zkontrolujte zdali je Kinect spravne pripojeny do elektricke site.<br>3. Zkontrolujte zdali je Kinect spravne pripojeny k Vasemu PC.</center>");

		}
		
		setLoadingProgress("Priprava OpenGL...", 60);
		main_panel = new ViewerPanel();
		myKinect.setViewer(main_panel);
		p_root.add(main_panel, BorderLayout.CENTER);
	}

	public void GUIclosing() {
		myKinect.stop();
	}

	public static void main(String args[]) {

		createMainFrame("Znakova Rec App");
		app = new ZnakovaRecApp();
		setFrameSize(730, 570, null);

	}
}